import { ClassConstructor } from '../class-transformer';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from '../types';
export declare class ClassTransformerForArray {
    static instance: ClassTransformerForArray;
    plainMapValue<T>(classType: ClassConstructor<T>, array: unknown[] | unknown[][], options?: ArrayStorageOptions): Record<PropertyKey, unknown>;
    classMapValue<T>(classType: ClassConstructor<T>, object: Record<PropertyKey, unknown>, options?: ArrayStorageOptions): unknown[];
    plainArrayToClass<T>(classType: ClassConstructor<T>, array: unknown[], options?: ClassTransformForArrayOptions & {
        isArray?: false;
    }): T;
    plainArrayToClass<T>(classType: ClassConstructor<T>, array: unknown[][], options?: ClassTransformForArrayOptions & {
        isArray: true;
    }): T[];
    classToPlainArray<T>(object: T, options?: ClassToPlainArrayOptions): unknown[];
    classToPlainArray<T>(object: T[], options?: ClassToPlainArrayOptions): unknown[][];
    arrayTransformAndValidate<T extends object>(classType: ClassConstructor<T>, array: unknown[], options?: TransformValidationForArrayOptions & {
        isArray?: false;
    }): Promise<T>;
    arrayTransformAndValidate<T extends object>(classType: ClassConstructor<T>, array: unknown[][], options?: TransformValidationForArrayOptions & {
        isArray: true;
    }): Promise<T[]>;
}
//# sourceMappingURL=ClassTransformerForArray.d.ts.map