"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayMemberClass = void 0;
/* eslint-disable @typescript-eslint/no-non-null-assertion */
const common_errors_1 = require("common-errors");
const storages_1 = require("../storages");
function ArrayMemberClass(arrayMemberStorage) {
    const storage = arrayMemberStorage || storages_1.defaultArrayMemberStorage;
    if (!(storage instanceof storages_1.ArrayMemberStorage)) {
        throw new common_errors_1.TypeError(`storage must be instanceof ArrayMemberStorage: ${storage}`);
    }
    return (constructor) => {
        var _a, _b;
        if (!storages_1.arrayMemberClassStorage.has(constructor)) {
            storages_1.arrayMemberClassStorage.set(constructor, []);
        }
        const storages = storages_1.arrayMemberClassStorage.get(constructor);
        if (!storages.includes(storage)) {
            storages.push(storage);
        }
        const result = storages_1.defaultArrayMemberStorage.map.get(constructor);
        if (result) {
            const defaultPropertyIndexMap = new Map(result);
            for (const [i, k] of (_b = (_a = storage.map.get(constructor)) === null || _a === void 0 ? void 0 : _a.entries()) !== null && _b !== void 0 ? _b : []) {
                defaultPropertyIndexMap.set(i, k);
            }
            storage.map.set(constructor, defaultPropertyIndexMap);
        }
    };
}
exports.ArrayMemberClass = ArrayMemberClass;
//# sourceMappingURL=ArrayMemberClass.js.map