import { ClassConstructor } from './class-transformer';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from './types';
export * from './decorators';
export * from './storages';
export * from './exceptions';
export * from './types';
export * from './core';
export declare function plainMapValue<T>(classType: ClassConstructor<T>, array: unknown[] | unknown[][], options?: ArrayStorageOptions): Record<PropertyKey, unknown>;
export declare function classMapValue<T>(classType: ClassConstructor<T>, object: Record<PropertyKey, unknown>, options?: ArrayStorageOptions): unknown[];
export declare function plainArrayToClass<T>(classType: ClassConstructor<T>, array: unknown[], options?: ClassTransformForArrayOptions & {
    isArray?: false;
}): T;
export declare function plainArrayToClass<T>(classType: ClassConstructor<T>, array: unknown[][], options?: ClassTransformForArrayOptions & {
    isArray: true;
}): T[];
export declare function classToPlainArray<T>(object: T, options?: ClassToPlainArrayOptions): unknown[];
export declare function classToPlainArray<T>(object: T[], options?: ClassToPlainArrayOptions): unknown[][];
export declare function arrayTransformAndValidate<T extends object>(classType: ClassConstructor<T>, array: unknown[], options?: TransformValidationForArrayOptions & {
    isArray?: false;
}): Promise<T>;
export declare function arrayTransformAndValidate<T extends object>(classType: ClassConstructor<T>, array: unknown[][], options?: TransformValidationForArrayOptions & {
    isArray: true;
}): Promise<T[]>;
//# sourceMappingURL=index.d.ts.map