"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayTransformAndValidateTest = void 0;
const mocha_1 = require("@testdeck/mocha");
const chai_1 = __importStar(require("chai"));
const chai_as_promised_1 = __importDefault(require("chai-as-promised"));
const src_1 = require("../src");
const UnknownClassError_1 = require("./../src/exceptions/UnknownClassError");
const CustomStorageClass_1 = require("./classes/CustomStorageClass");
const PassClassTransformOption_1 = require("./classes/PassClassTransformOption");
const Product_1 = require("./classes/Product");
const factories_1 = require("./factories");
chai_1.default.use(chai_as_promised_1.default);
let ArrayTransformAndValidateTest = class ArrayTransformAndValidateTest {
    async normal() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        Product_1.productValidate(expected, await src_1.arrayTransformAndValidate(Product_1.Product, expected.toPlainArray()));
    }
    async array() {
        const testData = factories_1.factory.make(Product_1.Product).many(2);
        const results = await src_1.arrayTransformAndValidate(Product_1.Product, testData.map((o) => o.toPlainArray()), { isArray: true });
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(testData.length);
        1;
        for (const [i, expected] of testData.entries()) {
            chai_1.expect(results).property(i.toString());
            Product_1.productValidate(expected, results[i]);
        }
    }
    async transformOption() {
        const expected = factories_1.factory.make(PassClassTransformOption_1.PassClassTransformOption).one();
        const result = await src_1.arrayTransformAndValidate(PassClassTransformOption_1.PassClassTransformOption, expected.toPlainArray(), {
            transformer: { strategy: 'excludeAll' },
        });
        PassClassTransformOption_1.passClassTransformOptionValidate(expected, result);
    }
    async fail() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        const plainArray = expected.toPlainArray();
        plainArray[1] = plainArray[1].toString();
        await chai_1.expect(src_1.arrayTransformAndValidate(Product_1.Product, plainArray)).rejected;
    }
    async customStorage() {
        const expected = factories_1.factory.make(CustomStorageClass_1.CustomStorageClass).one();
        CustomStorageClass_1.customStorageValidate(expected, await src_1.arrayTransformAndValidate(CustomStorageClass_1.CustomStorageClass, expected.toPlainArray(), { arrayMemberStorage: CustomStorageClass_1.arrayMemberStorage }));
    }
    async customStorageFail() {
        const expected = factories_1.factory.make(CustomStorageClass_1.CustomStorageClass).one();
        await chai_1.expect(src_1.arrayTransformAndValidate(CustomStorageClass_1.CustomStorageClass, expected.toPlainArray())).rejectedWith(UnknownClassError_1.UnknownClassError);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "array", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "transformOption", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "fail", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "customStorage", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "customStorageFail", null);
ArrayTransformAndValidateTest = __decorate([
    mocha_1.suite()
], ArrayTransformAndValidateTest);
exports.ArrayTransformAndValidateTest = ArrayTransformAndValidateTest;
//# sourceMappingURL=arrayTransformAndValidate.test.js.map