"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.passClassTransformOptionArrayValidate = exports.passClassTransformOptionValidate = exports.PassClassTransformOption = void 0;
const chai_1 = require("chai");
const class_fixtures_factory_1 = require("class-fixtures-factory");
const class_transformer_1 = require("class-transformer");
const faker_1 = __importDefault(require("faker"));
const src_1 = require("../../src");
const validate_1 = require("../factories/validate");
class PassClassTransformOption {
    constructor() {
        this.id = 0;
        this.title = '';
    }
    toPlainArray() {
        return [this.id, this.title];
    }
}
__decorate([
    src_1.ArrayMember(0),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number({ min: 1 })),
    __metadata("design:type", Object)
], PassClassTransformOption.prototype, "id", void 0);
__decorate([
    src_1.ArrayMember(1),
    class_transformer_1.Expose(),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number().toString()),
    __metadata("design:type", Object)
], PassClassTransformOption.prototype, "title", void 0);
exports.PassClassTransformOption = PassClassTransformOption;
function passClassTransformOptionValidate(expected, result, options = validate_1.defaultValidateOptions) {
    chai_1.expect(result).not.null;
    if (options.constructor) {
        chai_1.expect(result).property('constructor', PassClassTransformOption);
    }
    chai_1.expect(result).property('id', 0);
    chai_1.expect(result).property('title', expected.title);
}
exports.passClassTransformOptionValidate = passClassTransformOptionValidate;
function passClassTransformOptionArrayValidate(expected, result) {
    chai_1.expect(result).not.null;
    chai_1.expect(result).property('constructor', Array);
    chai_1.expect(result).length(2);
    chai_1.expect(result).property('0').is.undefined;
    chai_1.expect(result).property('1', expected.title);
}
exports.passClassTransformOptionArrayValidate = passClassTransformOptionArrayValidate;
//# sourceMappingURL=PassClassTransformOption.js.map